;;; Public Domain 2016
;;;  lidnariq

;;; In countries that do not honor public domain assignment, this is
;;; available under your choice of the WTFPL and CC-0.


.macpack generic
.include "constants.ca65.inc"

	;; bitbang out RS170 over DPCM DAC:

SYNCVOLTAGE = 127
BLACKVOLTAGE = 64
GREYVOLTAGE = 0

.ZEROPAGE
scanlinecounter: .byte 0
joypad: .byte 0
backgroundcolor: .byte 0
trashA = $5F00

.macro	nop3cy
	bit $FF
.endmacro

.macro	nop4cy
	sta trashA
.endmacro

.macro	nop5cy
	sta trashA,x
.endmacro
	
.macro	nop6cy
	dec trashA
.endmacro

.macro	nop7cy
	dec trashA,x
.endmacro
	
.segment "HEADER"
	.byte "NES",$1A
	.byte 1,0
	.byte 0,8
	.byte 0,0
	.byte 0,$04

	;; assume that a full 128 counts is 1V... probably not true.
.CODE
.proc VisibleScanlineSub
	;; consumes 31+12 cy
	lda #BLACKVOLTAGE ; 2 front porch should last 1.4us = 2.5cy
	ldx #SYNCVOLTAGE ; 4 can't get shorter than 4cy, though
	sta APU_DAC ; 8
	stx APU_DAC ; 12
	nop4cy ; 16 sync tip should last for 4.7us = 8.5cy
	sta APU_DAC ; 20 we'll just always use 8cy
	nop3cy ; 23 back porch should last for 4.8us = 8.6cy
	lda #GREYVOLTAGE ; 25 only place we use this, gotta put it back after
	sta APU_DAC ; 29
	lda #BLACKVOLTAGE ; 31
	;; NTSC/Dendy: scanlines are exactly 113+2/3 cy long.
	rts ; lose 12 additional cy to jsr/rts
.endproc

;;; the three scanlines before true vsync
.proc ShortPulse
	;; consumes 8+12 cy
	stx APU_DAC
	sta APU_DAC
	rts
.endproc

;;; for all the idle scanlines
.proc NormalPulse
	;; consumes 12+12cy
	stx APU_DAC
	nop4cy
	sta APU_DAC
	rts
.endproc

;;; The long pulses during vsync are 48cy long, although one of them
;;; has to be 47cy. The gaps of blanking between are 9cy:
.proc GapBetweenLongPulse
	;; consumes 13+12cy
	sta APU_DAC
	nop5cy
	stx APU_DAC
	rts
.endproc

.proc W
t90cy:	.byte $C9
t89cy:	.byte $C9
t88cy:	.byte $C9
t87cy:	.byte $C9
t86cy:	.byte $C9
t85cy:	.byte $C9
t84cy:	.byte $C9
t83cy:	.byte $C9
t82cy:	.byte $C9
t81cy:	.byte $C9
t80cy:	.byte $C9
t79cy:	.byte $C9
t78cy:	.byte $C9
t77cy:	.byte $C9
t76cy:	.byte $C9
t75cy:	.byte $C9
t74cy:	.byte $C9
t73cy:	.byte $C9
t72cy:	.byte $C9
t71cy:	.byte $C9
t70cy:	.byte $C9
t69cy:	.byte $C9
t68cy:	.byte $C9
t67cy:	.byte $C9
t66cy:	.byte $C9
t65cy:	.byte $C9
t64cy:	.byte $C9
t63cy:	.byte $C9
t62cy:	.byte $C9
t61cy:	.byte $C9
t60cy:	.byte $C9
t59cy:	.byte $C9
t58cy:	.byte $C9
t57cy:	.byte $C9
t56cy:	.byte $C9
t55cy:	.byte $C9
t54cy:	.byte $C9
t53cy:	.byte $C9
t52cy:	.byte $C9
t51cy:	.byte $C9
t50cy:	.byte $C9
t49cy:	.byte $C9
t48cy:	.byte $C9
t47cy:	.byte $C9
t46cy:	.byte $C9
t45cy:	.byte $C9
t44cy:	.byte $C9
t43cy:	.byte $C9
t42cy:	.byte $C9
t41cy:	.byte $C9
t40cy:	.byte $C9
t39cy:	.byte $C9
t38cy:	.byte $C9
t37cy:	.byte $C9
t36cy:	.byte $C9
t35cy:	.byte $C9
t34cy:	.byte $C9
t33cy:	.byte $C9
t32cy:	.byte $C9
t31cy:	.byte $C9
t30cy:	.byte $C9
t29cy:	.byte $C9
t28cy:	.byte $C9
t27cy:	.byte $C9
t26cy:	.byte $C9
t25cy:	.byte $C9
t24cy:	.byte $C9
t23cy:	.byte $C9
t22cy:	.byte $C9
t21cy:	.byte $C9
t20cy:	.byte $C9
t19cy:	.byte $C9
t18cy:	.byte $C9
t17cy:	.byte $C9 ; cmp imm:$C9
t16cy:	.byte $C9 ; cmp imm:$C5
t15cy:	.byte $C5 ; cmp zp:$EA
t14cy:	nop
	rts
.endproc

.proc ReadJoy
	lda #1
	sta JOY_1
	lda #0
	sta JOY_1
	lda JOY_1
	lsr A
	rol joypad
	lda JOY_1
	lsr A
	rol joypad
	lda JOY_1
	lsr A
	rol joypad
	lda JOY_1
	lsr A
	rol joypad
	lda JOY_1
	lsr A
	rol joypad
	lda JOY_1
	lsr A
	rol joypad
	lda JOY_1
	lsr A
	rol joypad
	lda JOY_1
	lsr A
	rol joypad
	rts
.endproc	
	
.proc Reset
	;;  universal resets:
	sei
	cld

	ldx #0
	stx PPU_CTRL
	stx PPU_MASK
	stx APU_PERIOD_DMC
	ldy #$40
	sty APU_MODE

	bit PPU_STATUS
	ldx #2
@wvblank:
	bit PPU_STATUS
	bpl @wvblank
	dex
	bne @wvblank

@clearingmemory:
	;; clear memory
	lda #0
	tax
@clrmem:	sta 0,x	; clear memory
	sta $100,x
	sta $200,x
	sta $300,x
	sta $400,x
	sta $500,x
	sta $600,x
	sta $700,x
	inx
	bne @clrmem
	dex
	txs

	;; Now upload tiles to CHR-RAM
	lda #0
	sta PPU_ADDR
	sta PPU_ADDR

	ldy #16
@nb1:
	sta PPU_DATA ; one tile, all color 0
	dey
	bne @nb1

	lda #$FF
	ldy #16
@nb2:
	sta PPU_DATA ; one tile, all color 3
	dey
	bne @nb2

	;; NTSC chroma timing-
	;;  282 visible and edge
	;;   38 front porch and hsync pulse
	;;   15 colorburst
	;;    6 remainder of back porch
	;; =341 total pixels
	
	;; clear nametable (all tile 0, all attribute 0)
	lda #$20
	sta PPU_ADDR
	lda #0
	sta PPU_ADDR
	tax
	ldy #4

@ntclear:
	sta PPU_DATA
	inx
	bne @ntclear
	dey
	bne @ntclear


	;; Now see if the user pressed some joypad combination on initial boot
	jsr ReadJoy
	lda joypad

	cmp #$01 ; right only
	beq @pu_rt
	cmp #$02 ; left only
	beq @pu_lt
	cmp #$04 ; down only
	beq @pu_dn
	cmp #$08 ; up only
	beq @pu_up
	cmp #$10 ; start only
	beq @pu_st
	cmp #$11 ; start+right
	beq @pu_st_rt
	cmp #$12 ; start+left
	beq @pu_st_lt
	cmp #$14 ; start+down
	beq @pu_st_dn
	cmp #$18 ; start+up
	beq @pu_st_up
	cmp #$20 ; select only
	beq @pu_sl
	cmp #$21 ; select+right
	beq @pu_sl_rt
	cmp #$22 ; select+left
	beq @pu_sl_lt
	cmp #$24 ; select+down
	beq @pu_sl_dn
	cmp #$28 ; select+up
	beq @pu_sl_up
	cmp #$30 ; start+select
	beq @pu_sl_st

	;; default
	lda #8
	sta backgroundcolor
	jmp @waitnojoy

	;; we know y is 0 going into here
@pu_rt:	iny
@pu_lt:	iny
@pu_dn:	iny
@pu_up:	iny
@pu_st_rt:	iny
@pu_st_lt:	iny
@pu_st_dn:	iny
@pu_st_up:	iny
@pu_sl_rt:	iny
@pu_sl_lt:	iny
@pu_sl_dn:	iny
@pu_sl_up:	iny
	sty backgroundcolor
	jmp @waitnojoy

@pu_st:	lda #$18
	sta backgroundcolor
	jmp @waitnojoy
@pu_sl:	lda #$28
	sta backgroundcolor
	jmp @waitnojoy
@pu_sl_st:	lda #$38
	sta backgroundcolor
	;jmp @waitnojoy

@waitnojoy:
	jsr ReadJoy
	lda joypad
	bne @waitnojoy


	;; Now upload palette
	lda #$3F
	sta PPU_ADDR
	lda #0
	sta PPU_ADDR

	lda backgroundcolor
	sta PPU_DATA
	lda #0
	sta PPU_DATA
	sta PPU_DATA
	sta PPU_DATA

	;; Now add a few no-color stripes

	;; Two horizontal ones, right at the top and bottom
	lda #$20
	sta PPU_ADDR
	lda #0
	sta PPU_ADDR
	lda #1
	ldx #32
@nthstripe1:
	sta PPU_DATA
	dex
	bne @nthstripe1

	lda #$23
	sta PPU_ADDR
	lda #$A0
	sta PPU_ADDR
	lda #1
	ldx #32
@nthstripe2:
	sta PPU_DATA
	dex
	bne @nthstripe2

	;; Four vertical ones, right in the middle
	
	lda #PPUCTRL::INC32
	sta PPU_CTRL
	lda #14
	sta joypad
	ldy #4

@nextstripe:
	lda #$20
	sta PPU_ADDR
	lda joypad
	sta PPU_ADDR
	inc joypad
	ldx #30
	lda #1
@ntvstripe:
	sta PPU_DATA
	dex
	bne @ntvstripe
	dey
	bne @nextstripe

	;; Now wait for vsync
@wvsync:
	bit PPU_STATUS
	bpl @wvsync

	ldy #0
	sty PPU_ADDR
	sty PPU_ADDR
	sty PPU_SCROLL
	sty PPU_SCROLL

	;; Enable video-
	lda #PPUMASK::BKGD_ENA
	sta PPU_MASK
	
;;; then we need to spin for long enough to place the visible period such
;;; that the TV receives our fake chroma burst. which is to say, we need to
;;; delay at least 21*341/3 cy. Later fine tuning can be done by the
;;; joypad... we'll poll every other vblank. (90pixels/sec is probably ok)


@startupwait1:
	dey
	bne @startupwait1 ; 1279
@startupwait2:
	dey
	bne @startupwait2 ; 2560... too long, but whatever.

	jmp BitBangRS170
.endproc



;;; never returns
.proc BitBangRS170
	;; what it says on the tin...
	ldx #SYNCVOLTAGE
	lda #BLACKVOLTAGE

	ldy #80
	sty scanlinecounter

@drawvisible:
	jsr VisibleScanlineSub ; 31+12
	jsr W::t71cy	; +59+12 = 114
	jsr VisibleScanlineSub
	jsr W::t71cy
	jsr VisibleScanlineSub ; 31+12
@fixup2:
	jsr W::t62cy ; +62+5+3 = 113

	dec scanlinecounter ; 5!!!
	bne @drawvisible ; when we fall through we're short by one, so...

	;; too early by 9cy?
	nop5cy ;5cy
	nop4cy ;4cy
	
	jsr ShortPulse
	jsr W::t37cy
	jsr ShortPulse
	jsr W::t37cy
	jsr ShortPulse
	jsr W::t37cy
	jsr ShortPulse
	jsr W::t37cy
	jsr ShortPulse
	jsr W::t37cy
	jsr ShortPulse
	jsr W::t42cy ; as a result we don't use the NormalizationShort here

	stx APU_DAC ; first actual vsync pulse starts here
	
	jsr W::t38cy
	jsr GapBetweenLongPulse ; normalization pulse
	jsr W::t32cy
	jsr GapBetweenLongPulse ; hsync
	jsr W::t32cy
	jsr GapBetweenLongPulse
	jsr W::t32cy
	jsr GapBetweenLongPulse ; hsync
	jsr W::t32cy
	jsr GapBetweenLongPulse
	jsr W::t37cy
	sta APU_DAC
	nop5cy
	stx APU_DAC ; end vsync; first hsync with normalization pulses
	sta APU_DAC

	jsr W::t43cy
	jsr ShortPulse
	jsr W::t37cy
	jsr ShortPulse
	jsr W::t37cy
	jsr ShortPulse
	jsr W::t37cy
	jsr ShortPulse
	jsr W::t37cy
	jsr ShortPulse
	jsr W::t36cy

	jsr NormalPulse
	;; check joypad

	ldy #1
	sty JOY_1
	dey
	sty JOY_1
	lda JOY_1
	lsr A
	rol joypad
	lda JOY_1
	lsr A
	rol joypad
	lda JOY_1
	lsr A
	rol joypad
	lda JOY_1
	lsr A
	rol joypad

	;; can't read it all in one scanline; do it in two

	;; burn 32cy
	jsr W::t32cy
	lda #BLACKVOLTAGE
	jsr NormalPulse

	lda JOY_1
	lsr A
	rol joypad
	lda JOY_1
	lsr A
	rol joypad
	lda JOY_1
	lsr A
	rol joypad
	lda JOY_1
	lsr A
	rol joypad

	jsr W::t44cy
	lda #BLACKVOLTAGE
	jsr NormalPulse

	lda #1
	bit joypad
	bne @joy_right
	lda #2
	bit joypad
	bne @joy_left
	lda #4
	bit joypad
	bne @joy_down
	lda #8
	bit joypad
	bne @joy_up
	lda #$40
	bit joypad
	bne @joy_b
	lda #$80
	bit joypad
	bne @joy_a
	jmp @joy_none

@joy_right:
	;; omit one cycle, then resume
	jsr W::t65cy
	jmp @joy_merge

@joy_left:
	;; insert one cycle, then resume
	jsr W::t60cy
	jmp @joy_merge

@joy_down:
	;; insert a whole scanline, then resume
	jsr W::t60cy
	ldx #SYNCVOLTAGE
	lda #BLACKVOLTAGE
	jsr NormalPulse
	jsr W::t78cy
	jmp @joy_merge

@joy_up:
	;; omit a whole scanline
	ldx #SYNCVOLTAGE
	lda #BLACKVOLTAGE
	ldy #3
	sty scanlinecounter
	jsr W::t48cy
	jmp @drawupperblanking

@joy_b:
	;; enable NMI, which uploads a new palette entry, and omit a matching number of cycles now
	inc backgroundcolor
	ldy #PPUCTRL::NMI_ENA
	sty PPU_CTRL

	;; need to elide 29cy now?
	ldx #SYNCVOLTAGE
	lda #BLACKVOLTAGE
	ldy #3
	sty scanlinecounter
	jsr W::t85cy ; fixup
	jmp @drawupperblanking

@joy_a:
	;; enable NMI, which uploads a new palette entry, and omit a matching number of cycles now
	dec backgroundcolor
	ldy #PPUCTRL::NMI_ENA
	sty PPU_CTRL

	;; need to elide 36cy now?
	ldx #SYNCVOLTAGE
	lda #BLACKVOLTAGE
	ldy #3
	sty scanlinecounter
	jsr W::t81cy
	jsr NormalPulse
	jsr W::t87cy
	jmp @joy_skip

@joy_none:
	jsr W::t32cy
@joy_merge:
	
	;; eat 10 scanlines
	ldx #SYNCVOLTAGE
	lda #BLACKVOLTAGE
	ldy #4
	sty scanlinecounter
	jmp @joy_skip2
	
@drawupperblanking:
	jsr NormalPulse ; 24
	jsr W::t90cy ; + 90 = 114
@joy_skip:
	jsr NormalPulse
	jsr W::t89cy
@joy_skip2:
	jsr NormalPulse ; 24
	jsr W::t82cy ; + 81
	dec scanlinecounter ; + 5
	bne @drawupperblanking ; + 3 = 113

	;; then draw the 2nd field

	ldy #80     ; 80 * 3 = 240 visible
	sty scanlinecounter

	;; will be too late by 12cy so inline first scanline
	
	;; A and X should still have correct values here
	nop
	stx APU_DAC
	nop4cy
	sta APU_DAC
	nop3cy
	lda #GREYVOLTAGE
	sta APU_DAC
	lda #BLACKVOLTAGE
	nop3cy
	jmp @fixup
	
	
@drawvisible2:
	jsr VisibleScanlineSub ; 31+12
@fixup:
	jsr W::t70cy	; +59+12 = 114
	jsr VisibleScanlineSub ; 43
	jsr W::t71cy	   ; +70 = 113
	jsr VisibleScanlineSub ; 31+12
	jsr W::t63cy ; +63+5+3 = 114

	dec scanlinecounter
	bne @drawvisible2 ; when we fall through we're short by one, so...

	nop4cy
	nop5cy
	
	jsr ShortPulse
	jsr W::t37cy
	jsr ShortPulse
	jsr W::t36cy
	jsr ShortPulse
	jsr W::t37cy
	jsr ShortPulse
	jsr W::t37cy ; cycles fixup
	jsr ShortPulse
	jsr W::t37cy
	jsr ShortPulse
	jsr W::t38cy

	ldy #5	; idle cycles here 
	sty scanlinecounter ; moved from later

	stx APU_DAC

	jsr W::t38cy
	jsr GapBetweenLongPulse
	jsr W::t31cy
	jsr GapBetweenLongPulse
	jsr W::t32cy
	jsr GapBetweenLongPulse
	jsr W::t32cy
	jsr GapBetweenLongPulse
	jsr W::t32cy
	jsr GapBetweenLongPulse
	jsr W::t38cy
	sta APU_DAC
	nop5cy
	stx APU_DAC
	sta APU_DAC

	jsr W::t43cy
	jsr ShortPulse
	jsr W::t36cy
	jsr ShortPulse
	jsr W::t37cy
	jsr ShortPulse
	jsr W::t37cy
	jsr ShortPulse
	jsr W::t37cy
	jsr ShortPulse
	jsr W::t37cy

	;; draw upper margin and finally restart

@drawupperblanking2:
	jsr NormalPulse ;24
	jsr W::t89cy ;90 - 114
	jsr NormalPulse
	jsr W::t90cy	; 24 + 89 = 113
	jsr NormalPulse 
	jsr W::t82cy ; 24 + 82 + 5 + 3 = 114
	dec scanlinecounter
	bne @drawupperblanking2

	;; fixup tail and restart
	nop
	ldy #80
	sty scanlinecounter
	
	stx APU_DAC ; have to inline this scanline
	nop4cy
	sta APU_DAC
	nop3cy
	lda #GREYVOLTAGE
	sta APU_DAC
	lda #BLACKVOLTAGE
	nop3cy

	jmp @fixup2
.endproc


;;; This NMI ONLY uploads a new palette entry
;;; NMIs are disabled in the main bitbang loop, to request a palette update
;;; during vblank
.proc NMI	            ; 6
	pha         ; 3
	;; upload new backdrop color
	bit PPU_STATUS ; 4
	lda #$3F       ; 2
	sta PPU_ADDR   ; 4
	lda #0         ; 2
	sta PPU_ADDR   ; 4
	lda backgroundcolor ; 3
	sta PPU_DATA	; 4
	;; reset scroll
	lda #0      ; 2
	sta PPU_SCROLL ; 4
	sta PPU_SCROLL ; 4
	;; and disable subsequent NMIs
	lda #PPUCTRL::NMI_DIS ; 2
	sta PPU_CTRL	  ; 4
	pla	  ; 3
	rti	  ; 6 -> 57cy
.endproc

.segment "VECTORS"
	.word NMI
	.word Reset
	.word Reset
